CON
{{
#############################################################
#                                                           #
# SID Polysynth v0.5 (05/08/2011)                           #
# by Alessandro De Luca                                     #
#                                                           #
# - using SIDcog 1.00 by Johannes Ahlebrand                 #
# - using StereoSpatializer 1.0 by Chip Gracey              #
# - using FullDuplexSerial4FC 1.1 by Tim Moore              #
#                                                           #
#############################################################
}}
CON
  '--- patch structure ---
   #0, name                                             '  0 -- STRING
  #16, do1_wf,     do1_pw,     do1_intval,  do1_detune  ' 16 \
       do1_lfoamt, do1_lfo2pw, do1_vel2pw,  do1_egttrk  ' 20 |
       do1_attack, do1_decay,  do1_sustain, do1_release ' 24 |
       mix_chorus, mix_reverb, vca_ctlbal,  vca_oscbal  ' 28 |
       do2_wf,     do2_pw,     do2_intval,  do2_detune  ' 32 |
       do2_lfoamt, do2_lfo2pw, do2_cat2pw,  do2_egttrk  ' 36 |_ BYTE
       do2_attack, do2_decay,  do2_sustain, do2_release ' 40 |
       lfo_wf,     lfo_rate,   lfo_delay,   lfo_mdest   ' 44 |
       vcf_cutoff, vcf_reson,  vcf_keyflw,  vcf_omask   ' 48 |
       vcf_lfoamt, vcf_envamt, vcf_velsns,  vcf_egttrk  ' 52 |
       vcf_attack, vcf_decay,  vcf_sustain, vcf_release ' 56 |
       RESERVED1,  RESERVED2,  RESERVED3,   RESERVED4   ' 60 /
  PATCH_SIZE    = 64                                    ' 64

'WARNING: *many* of the parameters have no effect with the current modulation model
'         they are included only for possible future enhancements.

PUB Load(ptr, n)
'PUB Load(n)
'  bytemove(@Patch, @Patch_Base + (n * PATCH_SIZE), PATCH_SIZE)
  bytemove(ptr, @Patch_Base + (n * PATCH_SIZE), PATCH_SIZE)
  return (@Patch_Base + (n * PATCH_SIZE))

CON
{
  switch controls    : $00=off $7F=on  ($40 is switchpoint)
  unipolar controls  : 0..127 unsigned ($40 is center)
  bipolar controls   : add bias 64     ($40 is center)
  mask controls      : e.g. bit masks, "as-is", up to 7 bits

  RESERVEDx candidate list:
        1. bender range (without using RPN?)
        2. initial modwheel value (so tones can have vibrato/chorus already active at start
        3. already have mdest (modulation destination), lfoamt is redundant
}
DAT
_aling        long      0
'Patch         byte      0[PATCH_SIZE]
Patch_Base    byte

{{ alternate E.Organ - this one is more VOX-ish and has less key click
  '-- OSC1 --
  byte      $40,$40,$40,$40     'VCO: p_do1_wf,     p_do1_pw,     p_do1_intval,  p_do1_detune
  byte      $00,$00,$00,$40     'MOD: x_do1_lfoamt, x_do1_lfo2pw, p_do1_cat2pw,  p_do1_egttrk
  byte      $00,$00,$60,$00     'ENV: p_do1_attack, p_do1_decay,  p_do1_sustain, p_do1_release
  '-- EFX/VCA --
  byte      $00,$00,$00,$40     'VCA: x_chorus,     x_reverb,     p_vca_ctlbal,  p_vca_oscbal
  '-- OSC2 --
  byte      $60,$40,$40,$40     'VCO: p_do2_wf,     p_do2_pw,     p_do2_intval,  p_do2_detune
  byte      $30,$00,$00,$40     'MOD: x_do2_lfoamt, x_do2_lfo2pw, p_do2_cat2pw,  p_do2_egttrk
  byte      $00,$00,$60,$00     'ENV: p_do2_attack, p_do2_decay,  p_do2_sustain, p_do2_release
  '-- LFO --
  byte      $40,$70,$00,$7F     'LFO: p_lfo_wf,     p_lfo_rate,   p_lfo_delay,   p_lfo_mdest
  '-- FILT --
  byte      $60,$40,$7F,$03     'VCF: p_vcf_cutoff, p_vcf_reson,  p_vcf_keyflw,  x_vcf_omask
  byte      $00,$40,$00,$40     'MOD: x_vcf_lfoamt, p_vcf_envamt, x_vcf_velsns,  p_vcf_egttrk
  byte      $00,$00,$60,$00     'ENV: p_vcf_attack, p_vcf_decay,  p_vcf_sustain, p_vcf_release
  '-- RESV --
  byte      $DE,$AD,$BE,$EF     'RSV: p_RESERVED1,  p_RESERVED2,  p_RESERVED3,   p_RESERVED4
}}

DAT
_Patch0
  '-- NAME --
_beg0
  byte      "001:E.Piano"       'p_name[16]
_end0
  byte      0[16 - (@_end0 - @_beg0)]
  '-- OSC1 --
  byte      $40,$40,$40,$40     'VCO: p_do1_wf,     p_do1_pw,     p_do1_intval,  p_do1_detune
  byte      $40,$00,$00,$58     'MOD: x_do1_lfoamt, x_do1_lfo2pw, p_do1_cat2pw,  p_do1_egttrk
  byte      $02,$30,$40,$20     'ENV: p_do1_attack, p_do1_decay,  p_do1_sustain, p_do1_release
  '-- EFX/VCA --
  byte      $00,$00,$7F,$00     'VCA: x_chorus,     x_reverb,     p_vca_ctlbal,  p_vca_oscbal
  '-- OSC2 --
  byte      $20,$40,$7F,$40     'VCO: p_do2_wf,     p_do2_pw,     p_do2_intval,  p_do2_detune
  byte      $00,$00,$00,$60     'MOD: x_do2_lfoamt, x_do2_lfo2pw, p_do2_cat2pw,  p_do2_egttrk
  byte      $01,$18,$40,$10     'ENV: p_do2_attack, p_do2_decay,  p_do2_sustain, p_do2_release
  '-- LFO --
  byte      $40,$40,$40,$00     'LFO: p_lfo_wf,     p_lfo_rate,   p_lfo_delay,   p_lfo_mdest
  '-- FILT --
  byte      $50,$40,$78,$03     'VCF: p_vcf_cutoff, p_vcf_reson,  p_vcf_keyflw,  x_vcf_omask
  byte      $00,$50,$00,$50     'MOD: x_vcf_lfoamt, p_vcf_envamt, x_vcf_velsns,  p_vcf_egttrk
  byte      $03,$58,$00,$30     'ENV: p_vcf_attack, p_vcf_decay,  p_vcf_sustain, p_vcf_release
  '-- RESV --
  byte      $DE,$AD,$BE,$EF     'RSV: p_RESERVED1,  p_RESERVED2,  p_RESERVED3,   p_RESERVED4

DAT
_Patch1
  '-- NAME --
_beg1
  byte      "002:E.Organ"       'p_name[16]
_end1
  byte      0[16 - (@_end1 - @_beg1)]
  '-- OSC1 --
  byte      $40,$40,$40,$40     'VCO: p_do1_wf,     p_do1_pw,     p_do1_intval,  p_do1_detune
  byte      $00,$00,$00,$50     'MOD: x_do1_lfoamt, x_do1_lfo2pw, p_do1_cat2pw,  p_do1_egttrk
  byte      $08,$18,$60,$18     'ENV: p_do1_attack, p_do1_decay,  p_do1_sustain, p_do1_release
  '-- EFX/VCA --
  byte      $00,$00,$00,$40     'VCA: x_chorus,     x_reverb,     p_vca_ctlbal,  p_vca_oscbal
  '-- OSC2 --
  byte      $60,$40,$40,$38     'VCO: p_do2_wf,     p_do2_pw,     p_do2_intval,  p_do2_detune
  byte      $30,$00,$00,$40     'MOD: x_do2_lfoamt, x_do2_lfo2pw, p_do2_cat2pw,  p_do2_egttrk
  byte      $04,$20,$60,$14     'ENV: p_do2_attack, p_do2_decay,  p_do2_sustain, p_do2_release
  '-- LFO --
  byte      $40,$70,$00,$7F     'LFO: p_lfo_wf,     p_lfo_rate,   p_lfo_delay,   p_lfo_mdest
  '-- FILT --
  byte      $60,$40,$60,$03     'VCF: p_vcf_cutoff, p_vcf_reson,  p_vcf_keyflw,  x_vcf_omask
  byte      $00,$28,$00,$40     'MOD: x_vcf_lfoamt, p_vcf_envamt, x_vcf_velsns,  p_vcf_egttrk
  byte      $10,$20,$60,$20     'ENV: p_vcf_attack, p_vcf_decay,  p_vcf_sustain, p_vcf_release
  '-- RESV --
  byte      $DE,$AD,$BE,$EF     'RSV: p_RESERVED1,  p_RESERVED2,  p_RESERVED3,   p_RESERVED4

DAT
_Patch2
  '-- NAME --
_beg2
  byte      "003:ElecBass"      'p_name[16]
_end2
  byte      0[16 - (@_end2 - @_beg2)]
  '-- OSC1 --
  byte      $20,$40,$00,$40     'VCO: p_do1_wf,     p_do1_pw,     p_do1_intval,  p_do1_detune
  byte      $40,$00,$00,$58     'MOD: x_do1_lfoamt, x_do1_lfo2pw, p_do1_cat2pw,  p_do1_egttrk
  byte      $01,$58,$00,$20     'ENV: p_do1_attack, p_do1_decay,  p_do1_sustain, p_do1_release
  '-- EFX/VCA --
  byte      $00,$00,$7F,$00     'VCA: x_chorus,     x_reverb,     p_vca_ctlbal,  p_vca_oscbal
  '-- OSC2 --
  byte      $00,$40,$7F,$40     'VCO: p_do2_wf,     p_do2_pw,     p_do2_intval,  p_do2_detune
  byte      $00,$00,$00,$60     'MOD: x_do2_lfoamt, x_do2_lfo2pw, p_do2_cat2pw,  p_do2_egttrk
  byte      $03,$58,$00,$20     'ENV: p_do2_attack, p_do2_decay,  p_do2_sustain, p_do2_release
  '-- LFO --
  byte      $40,$40,$40,$00     'LFO: p_lfo_wf,     p_lfo_rate,   p_lfo_delay,   p_lfo_mdest
  '-- FILT --
  byte      $50,$60,$78,$03     'VCF: p_vcf_cutoff, p_vcf_reson,  p_vcf_keyflw,  x_vcf_omask
  byte      $00,$50,$00,$50     'MOD: x_vcf_lfoamt, p_vcf_envamt, x_vcf_velsns,  p_vcf_egttrk
  byte      $02,$58,$00,$20     'ENV: p_vcf_attack, p_vcf_decay,  p_vcf_sustain, p_vcf_release
  '-- RESV --
  byte      $DE,$AD,$BE,$EF     'RSV: p_RESERVED1,  p_RESERVED2,  p_RESERVED3,   p_RESERVED4

DAT
_Patch3
  '-- NAME --
_beg3
  byte      "004:Flute"         'p_name[16]
_end3
  byte      0[16 - (@_end3 - @_beg3)]
  '-- OSC1 --
  byte      $00,$40,$40,$40     'VCO: p_do1_wf,     p_do1_pw,     p_do1_intval,  p_do1_detune
  byte      $00,$00,$00,$50     'MOD: x_do1_lfoamt, x_do1_lfo2pw, p_do1_cat2pw,  p_do1_egttrk
  byte      $28,$20,$68,$38     'ENV: p_do1_attack, p_do1_decay,  p_do1_sustain, p_do1_release
  '-- EFX/VCA --
  byte      $00,$00,$40,$10     'VCA: x_chorus,     x_reverb,     p_vca_ctlbal,  p_vca_oscbal
  '-- OSC2 --
  byte      $40,$40,$00,$3C     'VCO: p_do2_wf,     p_do2_pw,     p_do2_intval,  p_do2_detune
  byte      $20,$00,$00,$40     'MOD: x_do2_lfoamt, x_do2_lfo2pw, p_do2_cat2pw,  p_do2_egttrk
  byte      $28,$20,$68,$38     'ENV: p_do2_attack, p_do2_decay,  p_do2_sustain, p_do2_release
  '-- LFO --
  byte      $40,$60,$48,$7F     'LFO: p_lfo_wf,     p_lfo_rate,   p_lfo_delay,   p_lfo_mdest
  '-- FILT --
  byte      $60,$20,$60,$03     'VCF: p_vcf_cutoff, p_vcf_reson,  p_vcf_keyflw,  x_vcf_omask
  byte      $00,$38,$00,$40     'MOD: x_vcf_lfoamt, p_vcf_envamt, x_vcf_velsns,  p_vcf_egttrk
  byte      $28,$20,$68,$38     'ENV: p_vcf_attack, p_vcf_decay,  p_vcf_sustain, p_vcf_release
  '-- RESV --
  byte      $DE,$AD,$BE,$EF     'RSV: p_RESERVED1,  p_RESERVED2,  p_RESERVED3,   p_RESERVED4

DAT
_Patch4
  '-- NAME --
_beg4
  byte      "005:Strings"       'p_name[16]
_end4
  byte      0[16 - (@_end4 - @_beg4)]
  '-- OSC1 --
  byte      $20,$40,$40,$40     'VCO: p_do1_wf,     p_do1_pw,     p_do1_intval,  p_do1_detune
  byte      $00,$00,$00,$50     'MOD: x_do1_lfoamt, x_do1_lfo2pw, p_do1_cat2pw,  p_do1_egttrk
  byte      $48,$50,$68,$40     'ENV: p_do1_attack, p_do1_decay,  p_do1_sustain, p_do1_release
  '-- EFX/VCA --
  byte      $00,$00,$40,$40     'VCA: x_chorus,     x_reverb,     p_vca_ctlbal,  p_vca_oscbal
  '-- OSC2 --
  byte      $20,$40,$40,$48     'VCO: p_do2_wf,     p_do2_pw,     p_do2_intval,  p_do2_detune
  byte      $20,$00,$00,$40     'MOD: x_do2_lfoamt, x_do2_lfo2pw, p_do2_cat2pw,  p_do2_egttrk
  byte      $48,$50,$68,$40     'ENV: p_do2_attack, p_do2_decay,  p_do2_sustain, p_do2_release
  '-- LFO --
  byte      $00,$50,$50,$7F     'LFO: p_lfo_wf,     p_lfo_rate,   p_lfo_delay,   p_lfo_mdest
  '-- FILT --
  byte      $50,$40,$60,$03     'VCF: p_vcf_cutoff, p_vcf_reson,  p_vcf_keyflw,  x_vcf_omask
  byte      $00,$48,$00,$40     'MOD: x_vcf_lfoamt, p_vcf_envamt, x_vcf_velsns,  p_vcf_egttrk
  byte      $48,$50,$68,$40     'ENV: p_vcf_attack, p_vcf_decay,  p_vcf_sustain, p_vcf_release
  '-- RESV --
  byte      $DE,$AD,$BE,$EF     'RSV: p_RESERVED1,  p_RESERVED2,  p_RESERVED3,   p_RESERVED4

DAT
_Patch5
  '-- NAME --
_beg5
  byte      "006:PolySynth"     'p_name[16]
_end5
  byte      0[16 - (@_end5 - @_beg5)]
  '-- OSC1 --
  byte      $20,$40,$40,$40     'VCO: p_do1_wf,     p_do1_pw,     p_do1_intval,  p_do1_detune
  byte      $00,$00,$00,$48     'MOD: x_do1_lfoamt, x_do1_lfo2pw, p_do1_cat2pw,  p_do1_egttrk
  byte      $40,$60,$50,$4C     'ENV: p_do1_attack, p_do1_decay,  p_do1_sustain, p_do1_release
  '-- EFX/VCA --
  byte      $40,$40,$40,$40     'VCA: x_chorus,     x_reverb,     p_vca_ctlbal,  p_vca_oscbal
  '-- OSC2 --
  byte      $20,$40,$00,$48     'VCO: p_do2_wf,     p_do2_pw,     p_do2_intval,  p_do2_detune
  byte      $00,$00,$00,$40     'MOD: x_do2_lfoamt, x_do2_lfo2pw, p_do2_cat2pw,  p_do2_egttrk
  byte      $48,$5C,$50,$50     'ENV: p_do2_attack, p_do2_decay,  p_do2_sustain, p_do2_release
  '-- LFO --
  byte      $40,$50,$40,$00     'LFO: p_lfo_wf,     p_lfo_rate,   p_lfo_delay,   p_lfo_mdest
  '-- FILT --
  byte      $5A,$7F,$58,$03     'VCF: p_vcf_cutoff, p_vcf_reson,  p_vcf_keyflw,  x_vcf_omask
  byte      $00,$60,$00,$40     'MOD: x_vcf_lfoamt, p_vcf_envamt, x_vcf_velsns,  p_vcf_egttrk
  byte      $40,$60,$50,$50     'ENV: p_vcf_attack, p_vcf_decay,  p_vcf_sustain, p_vcf_release
  '-- RESV --
  byte      $DE,$AD,$BE,$EF     'RSV: p_RESERVED1,  p_RESERVED2,  p_RESERVED3,   p_RESERVED4

DAT
_Patch6
  '-- NAME --
_beg6
  byte      "007:SynDrums"      'p_name[16]
_end6
  byte      0[16 - (@_end6 - @_beg6)]
  '-- OSC1 --
  byte      $7F,$60,$40,$40     'VCO: p_do1_wf,     p_do1_pw,     p_do1_intval,  p_do1_detune
  byte      $00,$00,$00,$50     'MOD: x_do1_lfoamt, x_do1_lfo2pw, p_do1_cat2pw,  p_do1_egttrk
  byte      $08,$30,$00,$30     'ENV: p_do1_attack, p_do1_decay,  p_do1_sustain, p_do1_release
  '-- EFX/VCA --
  byte      $00,$00,$7F,$40     'VCA: x_chorus,     x_reverb,     p_vca_ctlbal,  p_vca_oscbal
  '-- OSC2 --
  byte      $40,$40,$00,$40     'VCO: p_do2_wf,     p_do2_pw,     p_do2_intval,  p_do2_detune
  byte      $7F,$00,$00,$48     'MOD: x_do2_lfoamt, x_do2_lfo2pw, p_do2_cat2pw,  p_do2_egttrk
  byte      $00,$30,$00,$08     'ENV: p_do2_attack, p_do2_decay,  p_do2_sustain, p_do2_release
  '-- LFO --
  byte      $00,$20,$00,$7F     'LFO: p_lfo_wf,     p_lfo_rate,   p_lfo_delay,   p_lfo_mdest
  '-- FILT --
  byte      $60,$50,$38,$03     'VCF: p_vcf_cutoff, p_vcf_reson,  p_vcf_keyflw,  x_vcf_omask
  byte      $00,$48,$00,$30     'MOD: x_vcf_lfoamt, p_vcf_envamt, x_vcf_velsns,  p_vcf_egttrk
  byte      $04,$28,$00,$28     'ENV: p_vcf_attack, p_vcf_decay,  p_vcf_sustain, p_vcf_release
  '-- RESV --
  byte      $DE,$AD,$BE,$EF     'RSV: p_RESERVED1,  p_RESERVED2,  p_RESERVED3,   p_RESERVED4

DAT
_Patch7
  '-- NAME --
_beg7
  byte      "008:SteamVax"      'p_name[16]   'FIXME: need parameter for initial ModWheel value!!!
_end7
  byte      0[16 - (@_end7 - @_beg7)]
  '-- OSC1 --
  byte      $7F,$60,$40,$40     'VCO: p_do1_wf,     p_do1_pw,     p_do1_intval,  p_do1_detune
  byte      $00,$00,$00,$50     'MOD: x_do1_lfoamt, x_do1_lfo2pw, p_do1_cat2pw,  p_do1_egttrk
  byte      $48,$60,$40,$58     'ENV: p_do1_attack, p_do1_decay,  p_do1_sustain, p_do1_release
  '-- EFX/VCA --
  byte      $00,$00,$00,$7F     'VCA: x_chorus,     x_reverb,     p_vca_ctlbal,  p_vca_oscbal
  '-- OSC2 --
  byte      $00,$40,$40,$40     'VCO: p_do2_wf,     p_do2_pw,     p_do2_intval,  p_do2_detune
  byte      $7F,$00,$00,$40     'MOD: x_do2_lfoamt, x_do2_lfo2pw, p_do2_cat2pw,  p_do2_egttrk
  byte      $48,$60,$40,$58     'ENV: p_do2_attack, p_do2_decay,  p_do2_sustain, p_do2_release
  '-- LFO --
  byte      $7F,$08,$58,$7F     'LFO: p_lfo_wf,     p_lfo_rate,   p_lfo_delay,   p_lfo_mdest
  '-- FILT --
  byte      $5F,$7F,$7F,$03     'VCF: p_vcf_cutoff, p_vcf_reson,  p_vcf_keyflw,  x_vcf_omask
  byte      $00,$00,$00,$40     'MOD: x_vcf_lfoamt, p_vcf_envamt, x_vcf_velsns,  p_vcf_egttrk
  byte      $48,$60,$40,$58     'ENV: p_vcf_attack, p_vcf_decay,  p_vcf_sustain, p_vcf_release
  '-- RESV --
  byte      $DE,$AD,$BE,$EF     'RSV: p_RESERVED1,  p_RESERVED2,  p_RESERVED3,   p_RESERVED4

CON